﻿Imports System.Drawing.Text

Public Class Form1

  Dim FontFamilies() As FontFamily
  Dim NumberOfFamilies As Integer
  Dim spacing As Integer = 28
  Dim NumberOfLinesVisible As Integer
  Dim Fstyle As FontStyle

  Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    Dim InstalledFonts As New InstalledFontCollection
    FontFamilies = InstalledFonts.Families
    NumberOfFamilies = FontFamilies.Count()
    NumberOfLinesVisible = PictureBox1.Height \ spacing
    VScrollBar1.LargeChange = NumberOfLinesVisible
    VScrollBar1.Maximum = NumberOfFamilies
    Fstyle = FontStyle.Regular
    RadioButton1.Checked = True
  End Sub

  Private Sub PictureBox1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
    Dim g As Graphics = e.Graphics
    For i As Integer = 0 To NumberOfFamilies - 1
      Dim y As Integer = (-VScrollBar1.Value + i) * spacing
      If y > -spacing And y < PictureBox1.Height Then
        g.DrawLine(Pens.Pink, 0, y + 20, PictureBox1.Width, y + 20)
        g.DrawLine(Pens.PaleTurquoise, 0, y, PictureBox1.Width, y)
        g.DrawString(FontFamilies(i).Name, New Font("Ariel", 12), Brushes.Black, 0, y + 4)
        Try
          g.DrawString("ABCDEFG abcdefg 1234567890 £$%^&*", New Font(FontFamilies(i), 16, Fstyle), Brushes.Black, 250, y)
        Catch
          g.DrawString("This style is not supported", New Font("Ariel", 10), Brushes.Black, 250, y + 8)
        End Try
      End If
    Next
  End Sub

  Private Sub VScrollBar1_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles VScrollBar1.ValueChanged
    PictureBox1.Invalidate()
  End Sub

  Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton1.CheckedChanged, RadioButton2.CheckedChanged, RadioButton3.CheckedChanged, RadioButton4.CheckedChanged, RadioButton6.CheckedChanged, RadioButton5.CheckedChanged
    Select Case True
      Case RadioButton1.Checked : Fstyle = FontStyle.Regular
      Case RadioButton2.Checked : Fstyle = FontStyle.Bold
      Case RadioButton3.Checked : Fstyle = FontStyle.Italic
      Case RadioButton4.Checked : Fstyle = FontStyle.Bold Or FontStyle.Italic
      Case RadioButton5.Checked : Fstyle = FontStyle.Strikeout
      Case RadioButton6.Checked : Fstyle = FontStyle.Underline
    End Select
    PictureBox1.Invalidate()
  End Sub
End Class
